﻿/*
*  @public
*  CSettings class is responsible for loading the course settings
*/
package 
{
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.*;
	import flash.net.*;
	import flash.events.EventDispatcher;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.xml.*;
	import flash.geom.ColorTransform;
	
	public class CSettings extends MovieClip 
	{
		public var XMLData:XML;
		public var delivery:String;
		public var forcedNavigation:String;
		public var debug:String;

		/*
		*  @public
		*  class constructor
		*/
		public function CSettings()
		{
	
			this.loadXML();
		}
		
		/*
		*  @private
		*  loads the main settings XML file
		*/
		private function loadXML():void
		{
			var loader:URLLoader=new URLLoader();
			loader.addEventListener(Event.COMPLETE,completeHandler);
			
			var request:URLRequest=new URLRequest("settings.xml");
			try 
			{
				loader.load(request);
			} 
			catch(error:Error) 
			{
				trace('error Loading XML.');
			}
		}
		/*
		*  @private
		*  loade the XML data to the course
		*/
		private function completeHandler(e:Event):void
		{
			try {
			var loader:URLLoader=URLLoader(e.target);
			XMLData=new XML(loader.data);
			delivery = XMLData.attribute("delivery")
			trace(XMLData.attribute("forcedNavigation") + "jjjjj");
			forcedNavigation = XMLData.attribute("forcedNavigation")
			debug = XMLData.attribute("debug")
			
			dispatchEvent(new Event("onCSettingLoad"));
			} catch (err:Error) {
				trace("Could not loaded Course Setting:\n" + err.message);
			}
		}
		
		
	}
}