﻿/**
*  navigation class controls the main navigation in framework
*/
package {
	import flash.display.*;
	import flash.text.*;
	import flash.media.*;
	import flash.net.*;
	import flash.events.*;
	import flash.xml.*;

	public class Navigation extends MovieClip {
		public var swf:String;
		public var loader:Loader;
		public var Request:URLRequest;
		public var FW_interface:MovieClip;
		public var com_button:Array;
		public var nextEnabled:Boolean = false;
		
		/**
		 *  hold the hint of each button navigation (as tool tool tip);
		 */
		private var hint:String;

		/*
		*  @public
		*  class constructor
		*  initiating the navigation controls in the framework
		*/
		public function Navigation() {
			this.focusRect=false;
			interfaceControl.button_pause.title_txt.visible = false;
			interfaceControl.button_audio.title_txt.visible = false;

			interfaceControl.button_pause.buttonMode = true;
			interfaceControl.button_pause.tabEnabled = false;
			interfaceControl.button_pause.mouseChildren = false;

			interfaceControl.button_audio.buttonMode = true;
			interfaceControl.button_audio.tabEnabled = false;
			interfaceControl.button_audio.mouseChildren = false;

			interfaceControl.button_replay.buttonMode = true;
			interfaceControl.button_replay.tabEnabled = false;
			interfaceControl.button_replay.mouseChildren = false;

			interfaceControl.button_next.buttonMode = true;
			interfaceControl.button_next.tabEnabled = false;
			interfaceControl.button_next.mouseChildren = false;

			interfaceControl.button_back.buttonMode = true;
			
			interfaceControl.button_back.mouseChildren = false;
			interfaceControl.button_back.tabEnabled = false;
			
			interfaceControl.button_menu.buttonMode = true;
			interfaceControl.button_menu.tabEnabled = false;
			interfaceControl.button_menu.mouseChildren = false;

			com_button = new Array(interfaceControl.button_action,
			   interfaceControl.button_resources,
			   interfaceControl.button_glossary,
			   interfaceControl.button_help,
			   interfaceControl.button_exit);

			for (var i:int=0; i < com_button.length; i++) {
				com_button[i].id=i;
				com_button[i].buttonMode = true;
				com_button[i].tabEnabled = false;
				com_button[i].mouseChildren = false;
				com_button[i].addEventListener(MouseEvent.MOUSE_OVER ,buttonsOver);
				com_button[i].addEventListener(MouseEvent.MOUSE_OUT  ,buttonsOut);
				com_button[i].addEventListener(MouseEvent.MOUSE_DOWN ,creatComEvent);
			}
			interfaceControl.button_pause.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_next.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_audio.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_replay.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_back.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_menu.addEventListener(MouseEvent.MOUSE_OVER,onOver);

			interfaceControl.button_pause.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			interfaceControl.button_next.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			interfaceControl.button_audio.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			interfaceControl.button_replay.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			interfaceControl.button_back.addEventListener(MouseEvent.MOUSE_OUT,onOut);
			interfaceControl.button_menu.addEventListener(MouseEvent.MOUSE_OUT,onOut);

			interfaceControl.button_pause.addEventListener(MouseEvent.MOUSE_DOWN,creatPauseEvent);
			interfaceControl.button_next.addEventListener(MouseEvent.MOUSE_DOWN,creatNextEvent);
			interfaceControl.button_audio.addEventListener(MouseEvent.MOUSE_DOWN,creatAudioEvent);
			interfaceControl.button_replay.addEventListener(MouseEvent.MOUSE_DOWN,creatReplayEvent);
			interfaceControl.button_back.addEventListener(MouseEvent.MOUSE_DOWN,creatBackEvent);
			interfaceControl.button_menu.addEventListener(MouseEvent.MOUSE_DOWN,creatMenuEvent);

		}
		
		/*
		*  @public
		*  resetting the component buttons
		*/
		function restCom(){
			
			
			for (var i:int=0; i < com_button.length; i++) {
				com_button[i].gotoAndPlay("out");
			    com_button[i].title_txt.textColor = 0x0B76B4;
		
			}
		
		}
		
		/*
		*  @public
		*  disables the Next button
		*/
		public function disableNextButton():void {
			nextEnabled = false;
			interfaceControl.button_next.buttonMode = false;
			interfaceControl.button_next.gotoAndStop("off");
			interfaceControl.button_next.title_txt.visible = false;
			interfaceControl.button_next.removeEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_next.removeEventListener(MouseEvent.MOUSE_OUT,onOut);
		}
		/*
		*  @public
		*  disables the Back button
		*/
		public function disableBackButton():void {
			interfaceControl.button_back.buttonMode = false;
			interfaceControl.button_back.gotoAndStop("off");
			interfaceControl.button_back.title_txt.visible = false;
			interfaceControl.button_back.removeEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_back.removeEventListener(MouseEvent.MOUSE_OUT,onOut);
		}
		
		/*
		*  @public
		*  disables the Replay button
		*/
		public function disableReplayButton():void {
			interfaceControl.button_replay.buttonMode = false;
			interfaceControl.button_replay.gotoAndStop("Inactive State");
			interfaceControl.button_replay.removeEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_replay.removeEventListener(MouseEvent.MOUSE_OUT,onOut);
		}
		
		
		
		/*
		*  @public
		*  enables the Next button
		*/
		public function enableNextButton():void {
			nextEnabled = true;
			interfaceControl.button_next.buttonMode = true;
			interfaceControl.button_next.gotoAndStop("up");
			interfaceControl.button_next.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_next.addEventListener(MouseEvent.MOUSE_OUT,onOut);
		}
		/*
		*  @public
		*  enables the Back button
		*/
		public function enableBackButton():void {
			interfaceControl.button_back.buttonMode = true;
			interfaceControl.button_back.gotoAndStop("up");
			interfaceControl.button_back.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_back.addEventListener(MouseEvent.MOUSE_OUT,onOut);
		}
		
		/*
		*  @public
		*  enables the Replay button
		*/
		public function enableReplayButton():void {
			interfaceControl.button_replay.buttonMode = true;
			interfaceControl.button_replay.gotoAndStop("up");
			interfaceControl.button_replay.addEventListener(MouseEvent.MOUSE_OVER,onOver);
			interfaceControl.button_replay.addEventListener(MouseEvent.MOUSE_OUT,onOut);
		}
		
		
	
		/*
		*  @public
		*  caculates the width of the tracking bar
		*/
		public function setTrackRatio(ratio:int):void {
			interfaceControl.visual_indicator.trackMask.width = (ratio * 293)/100;

		}

		/*
		*  @public
		*  converting the Play/Pause button to the Play state
		*/
		public function buttonPlayState():void {

			interfaceControl.button_pause.toggleIcon.gotoAndStop("play");
			if(interfaceControl.button_pause.playText)
			interfaceControl.button_pause.title_txt.text = interfaceControl.button_pause.playText.toString();

			
		}

		/*
		*  @public
		*  converting the Play/Pause button to the Pause state
		*/
		public function buttonPauseState():void {
			interfaceControl.button_pause.toggleIcon.gotoAndStop("pause");
			if(interfaceControl.button_pause.pauseText)
			interfaceControl.button_pause.title_txt.text = interfaceControl.button_pause.pauseText.toString();
		}

		/*
		*  @public
		*  converting the Mute button to the On state
		*/
		public function buttonMuteOn():void {
			interfaceControl.button_audio.toggleIcon.gotoAndStop("on");
		}

		/*
		*  @public
		*  converting the Mute button to the Off state
		*/
		public function buttonMuteOff():void {
			interfaceControl.button_audio.toggleIcon.gotoAndStop("off");
		}

		/**
		 *  @public function
		 * set the text data of title and all like this that coming from an xml file;
		 */

		/*
		*  @public
		*  setting the title text
		*/
		public function setTitle(txt:String):void {
			interfaceControl.title_txt.htmlText = txt;
		}

		/*
		*  @public
		*  setting the lesson title text
		*/
		public function setLesson(txt:String):void {
			interfaceControl.lesson_txt.htmlText = txt;
		}

		/*
		*  @public
		*  setting the topic title text
		*/
		public function setTopic(txt:String):void {
			interfaceControl.topic_txt.htmlText = txt;
		}

		/*
		*  @public
		*  setting the page counter
		
		
		*/
		
		public function setpage_counter(txt:String):void {
			interfaceControl.page_counter.htmlText = txt;
		}
		/*
		*  @public
		*  sets the hint of the Next button
		*/
		public function setNextHint(txt:String):void {
			interfaceControl.button_next.hint = txt;
		}

		/*
		*  @public
		*  sets the hint of the Back button
		*/
		public function setBackHint(txt:String):void {

			interfaceControl.button_back.hint = txt;
		}

		/*
		*  @public
		*  sets the hint of the Play/Pause button
		*/
		public function setPlayPauseHint(txt1:String,txt2:String):void {
			interfaceControl.button_pause.playText=txt1;
			interfaceControl.button_pause.pauseText=txt2;
			//interfaceControl.button_pause.title_txt.text = txt ;

		}

		/*
		*  @public
		*  sets the hint of the Audio button
		*/
		public function setAudioHint(txt:String):void {
			interfaceControl.button_audio.hint = txt;
			interfaceControl.button_audio.title_txt.text = txt ;
		}
		
		
		public function setpp(txt:String):void {
			interfaceControl.pp.htmlText = txt ;
		}
		
		

		/*
		*  @public
		*  sets the hint of the Replay button
		*/
		public function setReplayHint(txt:String):void {
			interfaceControl.button_replay.hint = txt;
		}
		/*
		*  @public
		*  sets the hint of the Menu button
		*/
		public function setMenuHint(txt:String):void {
			interfaceControl.button_menu.hint = txt;
		}

		/*
		*  @public
		*  sets the text of the Action Plan button
		*/
		public function setAction(txt:String):void {
			interfaceControl.button_action.title_txt.text = txt;
		}

		/*
		*  @public
		*  sets the text of the Resources button
		*/
		public function setResources(txt:String):void {
			interfaceControl.button_resources.title_txt.text = txt;
		}

		/*
		*  @public
		*  sets the text of the Glossary button
		*/
		public function setGlossary(txt:String):void {
			interfaceControl.button_glossary.title_txt.text = txt;
		}

		/*
		*  @public
		*  sets the text of the Help button
		*/
		public function setHelp(txt:String):void {
			interfaceControl.button_help.title_txt.text = txt;
		}

		/*
		*  @public
		*  sets the text of the Exit button
		*/
		public function setExit(txt:String):void {

			interfaceControl.button_exit.title_txt.text = txt;
			trace(interfaceControl.button_exit.title_txt.text);
		}
	
		/*
		*  @public
		*  sets th e next button to flashing state
		*/
		public function setFlahingNextButton():void {
			interfaceControl.button_next.gotoAndPlay("flashing");
		}

		/*
		*  @private
		*  shows the Over state of the button and sets the hint text
		*/
		private function onOver(e:MouseEvent) {
			e.target.gotoAndStop("over");
			if (e.target.hint)
			{
				e.target.title_txt.text = e.target.hint ;
				
			}e.target.title_txt.visible = true;
		}

		
		/*
		*  @private
		*  shows the Out state of the button and clears the hint text
		*/
		private function onOut(e:MouseEvent) {
			e.target.gotoAndPlay("out");
			e.target.title_txt.visible = false;
			//e.target.title_txt.text = "";
		}
		
		/*
		*  @private
		*  shows the Over state of the button and sets the text color
		*/
		private function buttonsOver(e:MouseEvent) {
			e.target.gotoAndPlay("over");
			e.target.title_txt.textColor = 0xAB004C;
		}
		
		/*
		*  @private
		*  shows the Out state of the button and sets the text color
		*/
		private function buttonsOut(e:MouseEvent) {
			e.target.gotoAndPlay("out");
			e.target.title_txt.textColor = 0x0B76B4;
		}
		/**
		 *  @private function
		 * firing an event for all component buttons according its id   ;
		  */
		
		/*
		*  @private
		*  firing an event for all the component buttons depending on it's id
		*/
		private function creatComEvent(event:Event):void {
			
			restCom();
			
			event.target.removeEventListener(MouseEvent.MOUSE_OVER ,buttonsOver);
			event.target.removeEventListener(MouseEvent.MOUSE_OUT  ,buttonsOut);
			event.target.gotoAndPlay("over");
			event.target.title_txt.textColor = 0xAB004C;
			
			switch (event.target.id) {
				case 0 :
					dispatchEvent(new Event("onPressAction"));
					break;
				case 1 :
					dispatchEvent(new Event("onPressResources"));
					break;
				case 2 :
					dispatchEvent(new Event("onPressGlossary"));
					break;
				case 3 :
					dispatchEvent(new Event("onPressHelp"));
					break;
				case 4 :
					dispatchEvent(new Event("onPressExit"));
					break;
			}
		}
		
		/*
		*  @private
		*  firing an event for the Pause button
		*/
		private function creatPauseEvent(event:Event):void {
			dispatchEvent(new Event("onPause"));
		}
		
		/*
		*  @private
		*  firing an event for the Next button
		*/
		private function creatNextEvent(event:Event):void {
			if(event.target.buttonMode == false)return;
			dispatchEvent(new Event("onNext"));
		}
		
		/*
		*  @private
		*  firing an event for the Audio button
		*/
		private function creatAudioEvent(event:Event):void {
			if(event.target.buttonMode == false)return;
			dispatchEvent(new Event("onAudioVolume"));
		}

		/*
		*  @private
		*  firing an event for the Replay button
		*/
		private function creatReplayEvent(event:Event):void {
			if(event.target.buttonMode == false)return;
			dispatchEvent(new Event("onReplay"));
		}
		
		/*
		*  @private
		*  firing an event for the Back button
		*/
		private function creatBackEvent(event:Event):void {
			if(event.target.buttonMode == false)return;
			dispatchEvent(new Event("onBack"));
		}
		
		/*
		*  @private
		*  firing an event for the Menu button
		*/
		private function creatMenuEvent(event:Event):void {
			if(event.target.buttonMode == false)return;
			dispatchEvent(new Event("onMenu"));
		}
	}
}