﻿// use  pbl_m1_l1_a3_03.fla
/*
* @public class
* a class responsible for drag and drop questions
*/

package {
	import flash.display.MovieClip;
	import flash.display.*;
	import flash.text.*;
	import flash.media.*;
	import flash.net.*;
	import flash.events.*;
	import flash.xml.*;

	public class question_dd extends MovieClip {

		public var localContentLevel:MovieClip;
		public var evalNum:Number;
		public var yourOrder:Array;
		public var rightOrder:Array;
		public var toggleVar:Boolean;

		/*
		* @public
		* class constructor
		*/
		public function question_dd() {
			evalNum = 0;
			yourOrder  = new Array();
			rightOrder = new Array();
			toggleVar = true;
		}
		/*
		* @public
		* initiating the question screen
		*/
		public function initDDQuestion() {

			CGlobal.question_generic_lib.initQuestionScreen();
			localContentLevel = CGlobal.question_generic_lib.contentLevel;
			initAQL();
			initsettingsQDD();
			if (localContentLevel.randomise_option_positioning == "on") {
				CGlobal.question_generic_lib.randomiseOptionPositioning();
			}// end if
			autoPositionOptions();
			initScreenItems();
			initOptionFunctionality();
			//initAudio(localContentLevel);
		}// End of the function

		/*
		* @public
		* assigning the current stage to the global aql
		*/
		private function initAQL() {

			CGlobal.aql = this;
		}
		/*
		* @public
		* setting the question general default settings
		*/
		function initsettingsQDD() {
			localContentLevel.total_options = localContentLevel.aOptions.length;
			localContentLevel.total_slots = localContentLevel.numberSlots;
			localContentLevel.max_slotted = localContentLevel.total_slots;
			if (localContentLevel.total_options > localContentLevel.total_slots) {
				localContentLevel.evalNum = localContentLevel.total_slots;
			} else if (localContentLevel.total_slots > localContentLevel.total_options) {
				localContentLevel.evalNum = localContentLevel.total_options;
			} else {
				localContentLevel.evalNum = localContentLevel.max_slotted;
			}// end else if
			if (localContentLevel.max_attempts == 1) {
				localContentLevel.retry_button.visible = false;
			}// end if
			//@@//if (CGlobal.islAppRoot.islSettings.debug == 1) {
			for (var _loc2 = 1; _loc2 <= localContentLevel.total_slots; ++_loc2) {
				//trace(localContentLevel.aCorrectSlots[_loc2 - 1] + " uuuuu" );
				trace(localContentLevel + " localContentLevel");
				//localContentLevel["slot" + _loc2].destination_slot.text = localContentLevel.aCorrectSlots[_loc2 - 1];
			}// end of for
			for (var _loc1 = 0; _loc1 <= localContentLevel.total_options; ++_loc1) {
				
				
				trace(_loc1);
				trace(localContentLevel["option" + _loc1]);
				if (localContentLevel["option" + _loc1]) {
					//localContentLevel["option" + _loc1].drag_option.text = _loc1;
				}
			}// end of for
			//@@//}// end if
		}// End of the function

		/*
		* @public
		* positioning the answering options, using random ordera each time
		*/
		function autoPositionOptions() {
			var _loc4 = new Array();
			var _loc3 = new Array();
			for (var _loc2 = 1; _loc2 <= localContentLevel.total_options; ++_loc2) {
				_loc4.push(localContentLevel["holder" + _loc2].x);
				_loc3.push(localContentLevel["holder" + _loc2].y);
			}// end of for
			for (var _loc1 = 0; _loc1 < localContentLevel.total_options; ++_loc1) {
				if (CGlobal.question_generic_lib.randomOrder.length > 1) {
					curNum = CGlobal.question_generic_lib.randomOrder[_loc1];
				} else {
					curNum = _loc1 + 1;
				}// end else if
				localContentLevel["option" + curNum].x = _loc4[_loc1];
				localContentLevel["option" + curNum].y = _loc3[_loc1];
			}// end of for
		}// End of the function

		/*
		* @public
		* positioning the answering options in case of drag and drop questions
		*/
		function initScreenItems() {
			CGlobal.button_code_lib.deactivateButton(localContentLevel.evaluator_button);
			CGlobal.button_code_lib.deactivateButton(localContentLevel.retry_button);
			localContentLevel.toggle_button.visible = false;
			//localContentLevel.depthCounter = 1100;
			for (var _loc1 = 1; _loc1 <= localContentLevel.total_slots; ++_loc1) {
				localContentLevel["slot" + _loc1].xpos = localContentLevel["slot" + _loc1].x;
				localContentLevel["slot" + _loc1].ypos = localContentLevel["slot" + _loc1].y;
				localContentLevel["holder" + _loc1].xpos = localContentLevel["holder" + _loc1].x;
				localContentLevel["holder" + _loc1].ypos = localContentLevel["holder" + _loc1].y;
			}// end of for
			for (_loc1 = 1; _loc1 <= localContentLevel.total_options; ++_loc1) {
				localContentLevel["option" + _loc1].startX = localContentLevel["option" + _loc1].xpos = localContentLevel["option" + _loc1].x;
				localContentLevel["option" + _loc1].startY = localContentLevel["option" + _loc1].ypos = localContentLevel["option" + _loc1].y;
				localContentLevel["option" + _loc1].startDrag(true);
				localContentLevel["option" + _loc1].stopDrag();
				localContentLevel["option" + _loc1].showme_active = 0;
				localContentLevel["option" + _loc1].targetx = localContentLevel["slot" + _loc1].xpos;
				localContentLevel["option" + _loc1].targety = localContentLevel["slot" + _loc1].ypos;
				localContentLevel["option" + _loc1].slot = 0;
				localContentLevel["option" + _loc1].localContentLevel = localContentLevel;
				localContentLevel["holder" + _loc1].xpos = localContentLevel["holder" + _loc1].x;
				localContentLevel["holder" + _loc1].ypos = localContentLevel["holder" + _loc1].y;
			}// end of for

		}// End of the function
		
		/*
		* @public
		* turning the button off when the button is released
		*/
		function buttonOut(e:MouseEvent):void {
			           if(e.currentTarget.option_popup)
						e.currentTarget.option_popup.gotoAndPlay("off");
						if (localContentLevel.popupAudio == "on") {
							CGlobal.audio_code_lib.extraAudioStop(e.currentTarget.name);
						}// end if
					}
					var DragedItem:MovieClip;
		/*
		* @public
		* initiates the drag and drop functions when the button is pressed
		*/
		function buttonPress(e:MouseEvent):void {
			
			if(e.target.buttonMode == false ) return;
					
					// CGlobal.checkNameInList("slot",CGlobal.getHitMovies(e.currentTarget,localContentLevel));
					// ++depthCounter;
					//this.swapDepths(depthCounter);
					
					localContentLevel.setChildIndex(e.target,localContentLevel.numChildren-1);
					e.currentTarget.startDrag();  /// startDrag();
					DragedItem=e.currentTarget
					//if (e.currentTarget.dropTarget.name.indexOf("slot") > -1) 
					
					if(CGlobal.checkNameInList("slot",CGlobal.getHitMovies(DragedItem,localContentLevel)))
					{//trace(" buttonPress" + e.currentTarget  + " drop "  + e.currentTarget.dropTarget);
						DragedItem.slot = 0;
					}// end if
					if (localContentLevel.option_popup == "on") {
						if(DragedItem.option_popup)
						DragedItem.option_popup.gotoAndPlay("off");
					}// end if
					if (localContentLevel.popupAudio == "on") {
						CGlobal.audio_code_lib.extraAudioStop(DragedItem.name);
					}// end if
				}
				/*
				* @public
				* stops dragging when button is released
				*/
				function buttonRelease(e:MouseEvent):void {
					
					if(e.target.buttonMode == false) return;
					//trace(" uuupppppppp" + e.currentTarget);
					if(!DragedItem)
					return;
					DragedItem.stopDrag();
					SnapToLoc(DragedItem);
					setEvaluatorButtonStatus();
					
					if (localContentLevel.popupAudio == "on") {
						CGlobal.audio_code_lib.extraAudioStop(DragedItem.name);
					}// end if
				}
				
				function buttonOver(e:MouseEvent):void {
						// ++depthCounter;
						localContentLevel.setChildIndex(e.target,localContentLevel.numChildren-1);
						//this.swapDepths(depthCounter);
						if(e.currentTarget.option_popup)
						e.currentTarget.option_popup.gotoAndPlay("on");
						if (localContentLevel.popupAudio == "on") {
							CGlobal.audio_code_lib.extraAudioPlay(e.currentTarget.name);
						}// end if
					}
			/*
			* @public
			* changes the position of the dragged option as long as it's active
			*/
			function buttonEnterFrame(e:Event):void {
					
					if (e.target.showme_active == 1) {
						e.currentTarget.xdif = e.currentTarget.targetx - e.currentTarget.x;
						e.currentTarget.x = e.currentTarget.x + e.currentTarget.xdif / 5;
						e.currentTarget.ydif = e.currentTarget.targety - e.currentTarget.y;
						e.currentTarget.y = e.currentTarget.y + e.currentTarget.ydif / 5;
						if (Math.abs(e.currentTarget.xdif) < 5.000000E-001 && Math.abs(e.currentTarget.ydif) < 5.000000E-001) {
							e.currentTarget.x = e.currentTarget.targetx;
							e.currentTarget.y = e.currentTarget.targety;
						}// end if
					}// end if
				}
		/*
		* @public
		* controls options, allowing them to be dragged and placed in the right places
		*/
		function initOptionFunctionality() {
			for (var _loc2 = 1; _loc2 <= localContentLevel.total_options; ++_loc2) {

				localContentLevel["option" + _loc2].tabEnabled = false;
				localContentLevel["option" + _loc2].buttonMode = true;
				localContentLevel["option" + _loc2].mouseChildren = false;
				localContentLevel["option" + _loc2].addEventListener(MouseEvent.MOUSE_DOWN, buttonPress);
				localContentLevel["option" + _loc2].addEventListener(MouseEvent.MOUSE_UP, buttonRelease);


				
				/* localContentLevel["option" + _loc2].onReleaseOutside = function (){   //   > === pinding
				SnapToLoc(this);
				setEvaluatorButtonStatus(); 
				stopDrag ();
				}*/

				if (localContentLevel.option_popup == "on") {

					localContentLevel["option" + _loc2].addEventListener(MouseEvent.MOUSE_OVER, buttonOver);
					localContentLevel["option" + _loc2].addEventListener(MouseEvent.MOUSE_OUT, buttonOut);

					
				}// end if

				localContentLevel["option" + _loc2].addEventListener(Event.ENTER_FRAME, buttonEnterFrame);

				
			}// end of for
		}// End of the function

		
		/*
		* @public
		* snep the option to it's location and prevents options overlapping
		* in one position
		*/
		function SnapToLoc(me:MovieClip) {
			//trace(me.dropTarget.name+" jjjjjj" );//trace(me.dropTarget.name.indexOf("slot_label") + "me");
			
			if (CGlobal.checkNameInList("slot",CGlobal.getHitMovies(me,localContentLevel))  /*&& !CGlobal.checkNameInList("slot_label",CGlobal.getHitMovies(me,localContentLevel))*/ ) {
				//trace(me.dropTarget.name+" 555555555555555" );
				var i = 1;
				while (i <= localContentLevel.total_slots) {
					//trace ("while "+me.hitTestObject(localContentLevel["slot" + i]))
					//if (getChildByName(me.dropTarget) == localContentLevel["slot" + i]) {
	
						//if (me.hitTestObject(localContentLevel["slot" + i])){
						if (localContentLevel["slot" + i].hitTestPoint(me.root.mouseX,me.root.mouseY)){
						if (!isSlotFilled(i)) {
							
							//trace("  !isSlotFilled  ");
							++localContentLevel.total_slotted;
							//trace(++localContentLevel.total_slotted + "G" );
							me.x = localContentLevel["slot" + i].x;
						  //  trace(localContentLevel["slot" + i].x + "XX" );
							me.y = localContentLevel["slot" + i].y;
							me.slot = i;
							//return
							break;
	
						}
						
					   else if (localContentLevel["slot" + i].hitTestPoint(me.root.mouseX,me.root.mouseY)){
							
							
							
						}
						

						else {
							//trace("  isSlotFilledisSlotFilledisSlotFilled  ");
							me.x = me.xpos;
							me.y = me.ypos;
							me.slot = 0;
							//return
							
							
						}// end if
					}// end else if
					else {
							//trace("  isSlotFilledisSlotFilledisSlotFilled  ");
							me.x = me.xpos;
							me.y = me.ypos;
							me.slot = 0;
							//return
					}
					++i;
				}// end while
				/*me.x = me.xpos;
				me.y = me.ypos;*/
			
			
			} else if (CGlobal.checkNameInList("holder",CGlobal.getHitMovies(me,localContentLevel))) {
				    // trace(" h ooooooooooo l der ");
				            me.x = me.xpos;
							me.y = me.ypos;
							me.slot = 0;
							
							
				var ii = 1;
				while (ii <= localContentLevel.total_options) {
					if (getChildByName(me.dropTarget) == localContentLevel["holder" + ii]) {
						me.x = me.xpos = localContentLevel["holder" + ii].xpos;
						me.y = me.ypos = localContentLevel["holder" + ii].ypos;
						me.slot = 0;
						break;
					}// end if
					++ii;
				}// end while
			} else {
				me.x = me.xpos;
				me.y = me.ypos;
			}// end else if
			
		}// End of the function

		/*
		* @public
		* checks if the slot is already filled, helps in preventing the overlapping
		*/
		function isSlotFilled(sNum) {
			for (var _loc1 = 1; _loc1 <= localContentLevel.total_options; ++_loc1) {
				if (localContentLevel["option" + _loc1].slot == sNum) {
					return true;
				}// end if
			}// end of for
			return false;
		}// End of the function

		/*
		* @public
		* activate or deactivate the evaluation button depending on the question status
		*/
		function setEvaluatorButtonStatus() {
			localContentLevel.total_slotted = 0;
			for (s = 1; s <= localContentLevel.total_options; s++) {
				if (localContentLevel["option" + s].slot != 0) {
					++localContentLevel.total_slotted;
				}// end if
			}// end of for
			
			if (localContentLevel.total_slotted == localContentLevel.evalNum) {
				CGlobal.button_code_lib.activateButton(localContentLevel.evaluator_button);
			} else {
				CGlobal.button_code_lib.deactivateButton(localContentLevel.evaluator_button);
			}// end else if
		}// End of the function


		/*
		* @public
		* reset all the options to it's original places
		*/
		function resetOptions() {
			for (var _loc1 = 1; _loc1 <= localContentLevel.total_options; ++_loc1) {
				localContentLevel["option" + _loc1].x = localContentLevel["option" + _loc1].startX;
				localContentLevel["option" + _loc1].y = localContentLevel["option" + _loc1].startY;
				localContentLevel["option" + _loc1].slot = 0;
				localContentLevel["option" + _loc1].buttonMode = true;
				localContentLevel["option" + _loc1].mouseChildren = false;
				
				//localContentLevel["option" + _loc1].addEventListener(MouseEvent.MOUSE_DOWN, buttonPress);
				//localContentLevel["option" + _loc1].addEventListener(MouseEvent.MOUSE_UP, buttonRelease);
			}// end of for
		}// End of the function
		/*
		* @public
		* disable the options, it's not draggable or clickable
		*/
		function disableOptions() {
			for (var _loc1 = 1; _loc1 <= localContentLevel.total_options; ++_loc1) {
				localContentLevel["option" + _loc1].buttonMode = false;
				
				//localContentLevel["option" + _loc1].removeEventListener(MouseEvent.MOUSE_DOWN, buttonPress);
				//localContentLevel["option" + _loc1].removeEventListener(MouseEvent.MOUSE_UP, buttonRelease);
				
				
			}// end of for
		}// End of the function
		/*
		* @public
		* check the answer(s) and evaluate if they are true or wrong
		*/
		function evaluateAnswer() {
			localContentLevel.total_correct = 0;
			localContentLevel.total_selected = 0;
			for (i = 1; i <= localContentLevel.max_slotted; i++) {
				localContentLevel["option" + i].correct = 0;
			}// end of for
			for (i = 1; i <= localContentLevel.max_slotted; i++) {
				this_option = localContentLevel["option" + i];
				for (j = 0; j < localContentLevel.aCorrectSlots[i - 1].length; j++) {
					correct_answer = localContentLevel["slot" + localContentLevel.aCorrectSlots[i - 1][j]];
					if (this_option.x == correct_answer.x && this_option.y == correct_answer.y && correct_answer != null) {
						++localContentLevel.total_correct;
						localContentLevel["option" + i].correct = 1;
					}// end if
				}// end of for
			}// end of for
			if (localContentLevel.total_correct == localContentLevel.aCorrectSlots.length) {
				localContentLevel.question_is_correct = true;
			}// end if
		}// End of the function

		/*
		* @public
		* find and show the correct answer if the given answer is wrong
		*/
		function showCorrectAnswer() {
			if (localContentLevel.show_answer == "animate" && !localContentLevel.question_is_correct) {
				if (localContentLevel.total_options > localContentLevel.total_slots) {
					for (var _loc11 = localContentLevel.total_slots + 1; _loc11 <= localContentLevel.total_options; ++_loc11) {
						localContentLevel["option" + _loc11].x = localContentLevel["option" + _loc11].startX;
						localContentLevel["option" + _loc11].y = localContentLevel["option" + _loc11].startY;
					}// end of for
				}// end if
				for (var _loc1 = 1; _loc1 <= localContentLevel.total_slots; ++_loc1) {
					localContentLevel["option" + _loc1].showme_active = 1;
				}// end of for
			} else if (localContentLevel.show_answer == "ticks") {
				showTicks();
			} else if (localContentLevel.show_answer == "toggle") {
				localContentLevel.toggle_button.visible = true;
				initToggleBtn();
				showTicks();
			}// end else if
		}// End of the function


		/*
		* @public
		* show the right and wrong ticks with the evaluation
		*/
		function showTicks() {
			for (var _loc11 = 1; _loc11 <= localContentLevel.total_options; ++_loc11) {
				localContentLevel["option" + _loc11].evaluator_graphic.gotoAndStop("incorrect");
			}// end of for
			for (var _loc1 = 1; _loc1 <= localContentLevel.total_options; ++_loc1) {
				if (localContentLevel["option" + _loc1].correct) {
					localContentLevel["option" + _loc1].evaluator_graphic.gotoAndStop("correct");
				}// end if
			}// end of for
		}// End of the function


		/*
		* @public
		* hide the right and wrong ticks
		*/
		function hideTicks() {
			for (var _loc1 = 1; _loc1 <= localContentLevel.total_options; ++_loc1) {
				localContentLevel["option" + _loc1].evaluator_graphic.gotoAndStop(1);
			}// end of for
		}// End of the function

		/*
		* @public
		* initiate toggle button
		*/
		function initToggleBtn() {
			for (var i = 1; i <= localContentLevel.total_options; i++) {
				yourNum = localContentLevel["option" + i].slot;
				if (yourNum == 0) {
					yourOrder.push(localContentLevel["holder" + i]);
				} else {
					yourOrder.push(localContentLevel["slot" + yourNum]);
				}// end else if
				rightOrder.push(localContentLevel["slot" + i]);
			}// end of for
			for (var yy = 0; yy < yourOrder.length; yy++) {
				yourOrder[yy].xPos =  yourOrder[yy].x;
				yourOrder[yy].yPos =  yourOrder[yy].y;
				rightOrder[yy].xPos = rightOrder[yy].x;
				rightOrder[yy].yPos = rightOrder[yy].y;
			}// end of for
		}// End of the function

		/*
		* @public
		* trigger the required functions when the toggle button is released 
		*/
		function toggleButtonRelease() {
			if (toggleVar) {
				for (var xx = 0; xx < localContentLevel.total_options; xx++) {
					if (localContentLevel.total_slots >= localContentLevel.total_options) {
						localContentLevel["option" + (xx + 1)].x = rightOrder[xx].xPos;
						localContentLevel["option" + (xx + 1)].y = rightOrder[xx].yPos;
						continue;
					}// end if
					localContentLevel["option" + (xx + 1)].x = localContentLevel["option" + (xx + 1)].startX;
					localContentLevel["option" + (xx + 1)].y = localContentLevel["option" + (xx + 1)].startY;
					for (var s = 1; s <= localContentLevel.total_slots; s++) {
						localContentLevel["option" + s].x = rightOrder[s - 1].xPos;
						localContentLevel["option" + s].y = rightOrder[s - 1].yPos;
					}// end of for
				}// end of for
				hideTicks();
			} else {
				for (xx = 0; xx < localContentLevel.total_options; xx++) {
					localContentLevel["option" + (xx + 1)].x = yourOrder[xx].xPos;
					localContentLevel["option" + (xx + 1)].y = yourOrder[xx].yPos;
				}// end of for
				showTicks();
			}// end else if
			if (toggleVar) {
				toggleVar = false;
				localContentLevel.toggle_button.gotoAndPlay("off");
			} else {
				toggleVar = true;
				localContentLevel.toggle_button.gotoAndPlay("on");
			}// end else if
		}// End of the function
	}// end class
}//end packsge