﻿/**
*  trackBar class controls the tracking functions in the main framework
*  updates the tracking on screen with every screen
*/
package { 
	import flash.display.MovieClip;
	import flash.display.Sprite;
	public class trackBar extends Sprite {
		/**
		 *  @public
		 *  hold the main framework referance
		 */
		var framework:MovieClip; 
		/**
		 *  @public
		 *  hold the screens index
		 */
		var fn:Number;
		/**
		 *  @public function
		 *  class constructor
		 */
		public function trackBar(framework:MovieClip){
			/**
		 	 *  assigning the framework stage to our variable
		 	 */
			this.framework = framework;
		}
		/**
		 *  @public function
		 *  class's main function, updates the tracking on screen with every screen
		 */
		public function trackBarControl() { 
			/**
		 	 *  assigning the screen index to our variable
		 	 */
			fn = framework.fn;;
			var modL:Number = -1;
			for (var modC:Number=0; modC <= framework.courseA.all.length; modC++) {
				modL+= framework.courseA["all"]["M"+modC].length;
				if (fn <= modL) {
					var curL:Number = modL-fn;	
					//setting the track bar width
					framework.indicator.trackMask.width = 293 - ((curL/(framework.courseA["all"]["M"+modC].length)) * 293);
					//setting the page numbering values
					framework.page_counter.htmlText =  moduleNumber(modC) + ": Lesson " + getParentIndex() + " out of " + ((framework.courseA["lessonsNo"][modC])-1); 
					//setting the lesson title
					framework.lesson_txt.htmlText = framework.screenNode[fn].parent().parent().parent().title;
					//setting the activity and screen title
					framework.topic_txt.htmlText = framework.screenNode[fn].parent().parent().title + ", " + framework.screenNode[fn].parent().title; 
					break;

				}
			}
		}
		/**
		 *  @public function
		 *  returns the right module name and number in string format
		 */
		public function moduleNumber(modCN:Number /*module number*/):String {
			if ((modCN) == 0) {
				return framework.screenNode[fn].parent().parent().parent().title;
			} else {
				return ("Module " + modCN);
			}
		}
		/**
		 *  @public function
		 *  returns the activity index according to the module
		 */
		public function getParentIndex() {
			var curNodeParentId:String = framework.screenNode[fn].parent().parent().@id;
			for (var ppC:Number=0; ppC <= framework.screenNode[fn].parent().parent().parent().children().length(); ppC++) {
				var ppID:String = framework.screenNode[fn].parent().parent().parent().children()[ppC].@id;
				if (framework.screenNode[fn].parent().parent().@id == ppID) {
					return (ppC - 1);
					break;
				}
			}
		}
	}
}